package org.ubicollab.app.imgviewer.model;


//import no.ubicollab.app.imageviewer.model.Controller;
import java.util.Hashtable;


import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceRegistration;
import org.ubicollab.app.imgviewer.views.MainView;
/**
 * The activator class controls the plug-in life cycle
 */
public class Activator extends AbstractUIPlugin {
	
	
	/**
	 * @uml.property  name="deviceManager"
	 * @uml.associationEnd  
	 */
	private DeviceManager deviceManager = null;
	// The plug-in ID
	public static final String PLUGIN_ID = "org.ubicollab.app.imgviewer";

	// The shared instance
	/**
	 * @uml.property  name="plugin"
	 * @uml.associationEnd  
	 */
	private static Activator plugin;
	public static BundleContext bcontext;
	/**
	 * The constructor
	 */
	public Activator() {
	}

	/*
	 * (non-Javadoc)
	 * @see org.eclipse.ui.plugin.AbstractUIPlugin#start(org.osgi.framework.BundleContext)
	 */
	public void start(BundleContext context) throws Exception {
		this.bcontext=context;
		super.start(context);
		plugin = this;
		
		/*Not for the CLient version of the Plugin
		//WS registration
		Properties properties = new Properties();
		properties.put("Language", "English");
		properties.put("SOAP.service.name", "ImageViewer_Server");
		*/
		
		//Service Registration
		deviceManager = DeviceManager.getInstance();  //deviceManager is an implementation of imageviewer
		
		ServiceRegistration registration = context.registerService(ImageViewer.class.getName(), deviceManager, new Hashtable()); 
		System.out.println("Service registered: no.ubicollab.app.ImageViewer"); 
		
		/*
		WSController stub = null;
		String url = "http://169.254.2.1:8080/axis/services/ImageViewer_Server";
		ControllerServiceLocator locator = new ControllerServiceLocator();
		try {
			stub = locator.getImageViewer_Server(new java.net.URL(url));
			try {
				stub.drawNext();
			} catch (RemoteException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		} catch (MalformedURLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ServiceException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}*/

	}
		
		
		
		
		 
		
	/*
	 * (non-Javadoc)
	 * @see org.eclipse.ui.plugin.AbstractUIPlugin#stop(org.osgi.framework.BundleContext)
	 */
	public void stop(BundleContext context) throws Exception {
		plugin = null;
		super.stop(context);
	}

	/**
	 * Returns the shared instance
	 *
	 * @return the shared instance
	 */
	public static Activator getDefault() {
		return plugin;
	}

}
