package org.ubicollab.app.imgviewer.model;

import java.util.ArrayList;
import java.beans.XMLDecoder;
import java.beans.XMLEncoder;
import java.io.*;



public class ContentList {

	ArrayList<Content> list = null;
	String fileName;
	
	public ContentList()
	{
		list = new ArrayList<Content>();
		addDefaultContents();
		
	}
	
	
	private void updateServiceList()
	{
		list = new ArrayList<Content>();
		addDefaultContents();
		//Check which drive on the device is writable
		int storageWritable =0;
		for(int j=0;j<2;j++)
		{
			File checkIfWritable = new File(java.io.File.listRoots()[j].getAbsolutePath());
			if(checkIfWritable.canWrite())
				storageWritable = j;
		}
		String drive = java.io.File.listRoots()[storageWritable].getAbsolutePath();
		System.out.println("Device in use: "+drive);
		fileName = drive + Settings.STORAGE_ROOT + System.getProperty("file.separator") + Settings.CONTENTS_FILE;
		
		//Check if a customized copy of the Service List is locally available, if not it fill it
		//the default services
		File checkIfExists = new File(fileName);
		if(!checkIfExists.exists())
		{
			addDefaultContents();
			try {
				Thread.currentThread().setContextClassLoader(getClass().getClassLoader());
				writeToFile(list, fileName);
			} catch (Exception e) {
				System.out.println("Cannot write services.xml");
				e.printStackTrace();
			}
		}
		
		File path = new File(drive+Settings.STORAGE_ROOT);
		boolean directoryExist = true;
		if ( !path.exists() ) {
			directoryExist = path.mkdirs();
		}
		if ( !directoryExist ) {
			list = new ArrayList<Content>();
		}
		else {
			try {
				Thread.currentThread().setContextClassLoader(getClass().getClassLoader());
				list = (ArrayList<Content>) readFromFile(fileName);
			} catch (Exception e) {
				list = new ArrayList<Content>();
				e.printStackTrace();
			}
		}
	}


	
	private static void writeToFile(ArrayList sl, String filename) throws Exception {
        XMLEncoder encoder =
           new XMLEncoder(
              new BufferedOutputStream(
                new FileOutputStream(filename)));
        encoder.writeObject(sl);
        encoder.close();
    }
	
	private static ArrayList readFromFile(String filename) throws Exception {
        File f = new File(filename);
        ArrayList readObject;
        if ( f.exists() ) {
			XMLDecoder decoder = new XMLDecoder(new BufferedInputStream( new FileInputStream(filename)));
			readObject = (ArrayList) decoder.readObject();
			decoder.close();
		}
        else {
        	readObject = new ArrayList<Content>();
        }
        return readObject;
    }
	
	public ArrayList<Content> getContents()
	{
		return this.list;
	}
	
	public void addDefaultContents()
	{
		list.add(new Content("NTNU Logo","http://folk.ntnu.no/simonem/img_viewer/ntnu.jpg","ntnu.jpg"));
		list.add(new Content("NTNU Main Building","http://folk.ntnu.no/simonem/img_viewer/building.jpg","building.jpg"));
		list.add(new Content("Lake Flower","http://folk.ntnu.no/simonem/img_viewer/flower.jpg","flower.jpg"));
		list.add(new Content("Fjord","http://folk.ntnu.no/simonem/img_viewer/fjord.jpg","fjord.jpg"));		
	}
	
	public String toXML() {
		Content c;
		String xml = Settings.XML_HEADER;
		xml += "<Contentlist>";
		for (int i=0;i<list.size();i++) {
			c = list.get(i);
			xml += c.toXML(); 
		}
		xml += "</Servicelist>";
		return xml;
	}
}
