package org.ubicollab.app.imgviewer.views;



import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.part.ViewPart;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.*;
import org.eclipse.swt.graphics.*;
import org.eclipse.swt.widgets.Canvas;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.ercp.swt.mobile.*;
import org.osgi.framework.*;
import org.ubicollab.app.imgviewer.model.*;
import org.ubicollab.proxy.sharedscreen.ImagePresenterProxy;

import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;

import java.util.ArrayList;
import java.util.Vector;



/**
 * @author  Simone
 */
public class MainView extends ViewPart implements PaintListener, KeyListener, SelectionListener{
	
	BundleContext bc = Activator.bcontext;
    Canvas  canvas;
	int     drawCase=0;
	int     counter;
	boolean eraseBgd;
	Command commandExit;
	Command commandNext;
    private FocusListener superShellListener = null;
	Color col1;
	Color col2;
	public static final String ID = "MainView";
	/**
	 * @uml.property  name="deviceManager"
	 * @uml.associationEnd  
	 */
	DeviceManager deviceManager = null;
	static Composite parente = null;
	ServiceReference services[] = null;
	/**
	 * @uml.property  name="proxies"
	 * @uml.associationEnd  multiplicity="(0 -1)"
	 */
	ImagePresenterProxy proxies[] = null;
	ArrayList<Content> contents = null;
	
	public MainView() {	
		ContentList list = new ContentList();
		contents = list.getContents();
	}
	
	public void connectToRemoteDevices(Composite parent)
	{	
		deviceManager = DeviceManager.getInstance();
		String filter = "(objectclass=" + ImagePresenterProxy.class.getName() + ")"; 
		
		try {
			services = bc.getServiceReferences(ImagePresenterProxy.class.getName(), filter);
			proxies = (ImagePresenterProxy[])services;
		} catch (InvalidSyntaxException e) {
			e.printStackTrace();
		}
		System.out.println("ImageViewer\nNumber of remote presenter connected: " + services.length);		
		if(services.length!=0)
		{
		for(int i=0; i<services.length; i++)
		{
		System.out.println("Device connected: " + i);
		}
		
		MessageBox messageBox3 = new MessageBox(parent.getShell(),SWT.ICON_INFORMATION);
		messageBox3.setText("New Remote Presenter found!");
		if(deviceManager.size()!=0)
		{
			String devcon="";
			for(int j=0;j<deviceManager.size();j++)
			{
			devcon= devcon + deviceManager.get(j).getName()+"\n";
			}
			messageBox3.setMessage("Device Connected:\n"+ devcon);
		}
			else
			messageBox3.setMessage("No remote remote presenter connected.");	
			messageBox3.open();
		}
		}
	/**
	 * Create contents of the view part.
	 */
	public void createPartControl(Composite parent) {
	    parente=parent;
		canvas = new Canvas(parent, SWT.NO_BACKGROUND);
	    
	    //Splash message boxs
	    MessageBox messageBox = new MessageBox(parent.getShell());
		messageBox.setText("About");
		messageBox.setMessage("Hello, this is an application for the Ubicollab Platform");
		messageBox.open();
		
		MessageBox messageBox2 = new MessageBox(parent.getShell(),SWT.ICON_INFORMATION);
		messageBox.setText("How to Use");
		messageBox.setMessage("Tap on the screen to browse the photos");
		messageBox.open();
		
		connectToRemoteDevices(parent);
	
		//Listener on canvas
	    canvas.addMouseListener(new MouseListener() {
	    	public void mouseDoubleClick(MouseEvent arg0) {
	    	}
	    	public void mouseDown(MouseEvent arg0) {
	    	}
	    	public void mouseUp(MouseEvent arg0) {
					drawNext();
	    	}
	    });
	        
	    //Define the screen painting area
	    Rectangle area = parent.getClientArea();
	    canvas.setBounds(area);
	    canvas.addPaintListener(this);
	    canvas.addKeyListener(this);	
		eraseBgd = true;

		// create Commands			
		commandNext = new Command(canvas, Command.SELECT,3);
		commandNext.setText("command NEXT"); 
		commandNext.addSelectionListener(this);
		commandNext.setDefaultCommand();

		commandExit = new Command(canvas, Command.EXIT,1);
		commandExit.setText("exit"); 
		commandExit.setLongLabel("exit"); 
		commandExit.addSelectionListener(this);
	    canvas.setFocus();
	    
		//Bring up this cavas image if existed while clicking eSWT Demo shortcut.
		superShellListener = new FocusListener() {
			public void focusGained(FocusEvent arg0) {
				if(deviceManager.size() != services.length)
					connectToRemoteDevices(parente);
				if(canvas != null && !canvas.isDisposed()) {
					if(deviceManager.size() != services.length)
						connectToRemoteDevices(parente);
					eraseBgd = true;
					//Trigger a redraw event
					drawNext();
					canvas.forceFocus();
				}
			}
			public void focusLost(FocusEvent arg0) {
			}			
		};
	}

	//WS METHODS
    public void drawNext()
    {
    	if(drawCase < contents.size())
    		++drawCase;
    	else
    		drawCase = 0;
		eraseBgd = true;
		canvas.redraw();		
		if(deviceManager.size() != services.length)
			connectToRemoteDevices(parente);
		else
		{	
		for(int i=0;i<proxies.length;i++)
			proxies[i].showTarget(contents.get(drawCase).getFileName());
		}
    }

    //When a redraw event happen, it choose the next photo and draw it
	public void paintControl(PaintEvent e) {
		if (eraseBgd) {
			e.gc.fillRectangle(canvas.getClientArea());
			eraseBgd = false;
		}
		drawImage(e);
	}
	
	/**
	 * Press any key to go through the different screens
	 */
	public void keyPressed(KeyEvent e) {
	}
	
	public void keyReleased(KeyEvent e) {
	}
	
	/**
	 * display an image 
	 * 
	 * @param e	Paintevent
	 * @param name filename
	 */
	private void drawImage(PaintEvent e) {	
		String url = contents.get(drawCase).getURL();
		URL uri = null;
		try {
			uri = new URL(url);
		} catch (MalformedURLException e2) {
			System.out.println("Error: Cannot Retrive Content");
			e2.printStackTrace();
		}
		Image img2=null;
		try {
			 img2 = new Image(canvas.getDisplay(),uri.openStream());
			
		} catch (IOException e1) {
			System.out.println("Error: Cannot Retrive Content");
			e1.printStackTrace();
		}
		Rectangle imageBnds  = img2.getBounds();
		Rectangle canvasBnds = canvas.getBounds();
		int x = (canvasBnds.width  - imageBnds.width ) / 2;
		int y = (canvasBnds.height - imageBnds.height) / 2;
		GC gc = new GC(canvas, SWT.NONE);
		gc.fillRectangle(canvas.getClientArea());	
		gc.drawImage(img2, x, y);
		img2.dispose();
	}
		
	public void widgetSelected(SelectionEvent e) {
		if (e.widget==commandExit) {
			quit();
		}
		else if (e.widget==commandNext) {
			drawNext();
		}
	}
	
	public void quit() {
	    if (col1 != null) {
	        col1.dispose();
	    }
	    if (col2 != null) {
	        col2.dispose();
	    }
	    if(canvas.getShell() != null && !canvas.getShell().isDisposed())
		{	
	    	canvas.getParent().getShell().removeFocusListener(superShellListener);
		}   
	    canvas.getParent().redraw();
	    dispose();
	}
	public void widgetDefaultSelected(SelectionEvent e) {
 	}
	public void setFocus() {
	}
}
