/*
 * Copyright 2009 UbiCollab.org
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.ubicollab.rdp.tan.model;

/**
 * @author  Simone
 */
public class Service {
	
	/**
	 * @uml.property  name="id"
	 */
	private int id;
	/**
	 * @uml.property  name="name"
	 */
	private String name;
	/**
	 * @uml.property  name="type"
	 */
	private String type;
	/**
	 * @uml.property  name="location"
	 */
	private String location;
	/**
	 * @uml.property  name="owner"
	 */
	private String owner;
	/**
	 * @uml.property  name="description"
	 */
	private String description;
	/**
	 * @uml.property  name="serviceUri"
	 */
	private String serviceUri;
	/**
	 * @uml.property  name="descriptionUri"
	 */
	private String descriptionUri;
	
	public Service()
	{
		super();
	}
	
	public Service(int id, String name, String type, String location, String owner, String description, String serviceUri, String descriptionUri)
	{
		this.id=id;
		this.name=name;
		this.type=type;
		this.location=location;
		this.owner=owner;
		this.description=description;
		this.serviceUri=serviceUri;
		this.descriptionUri=descriptionUri;	
	}
	
	//Getters and Setters
	/**
	 * @return
	 * @uml.property  name="id"
	 */
	public int getId() {
		return id;
	}

	/**
	 * @param id
	 * @uml.property  name="id"
	 */
	public void setId(int id) {
		this.id = id;
	}

	/**
	 * @return
	 * @uml.property  name="name"
	 */
	public String getName() {
		return name;
	}

	/**
	 * @param name
	 * @uml.property  name="name"
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * @return
	 * @uml.property  name="type"
	 */
	public String getType() {
		return type;
	}

	/**
	 * @param type
	 * @uml.property  name="type"
	 */
	public void setType(String type) {
		this.type = type;
	}

	/**
	 * @return
	 * @uml.property  name="location"
	 */
	public String getLocation() {
		return location;
	}

	/**
	 * @param location
	 * @uml.property  name="location"
	 */
	public void setLocation(String location) {
		this.location = location;
	}

	/**
	 * @return
	 * @uml.property  name="owner"
	 */
	public String getOwner() {
		return owner;
	}

	/**
	 * @param owner
	 * @uml.property  name="owner"
	 */
	public void setOwner(String owner) {
		this.owner = owner;
	}

	/**
	 * @return
	 * @uml.property  name="description"
	 */
	public String getDescription() {
		return description;
	}

	/**
	 * @param description
	 * @uml.property  name="description"
	 */
	public void setDescription(String description) {
		this.description = description;
	}

	/**
	 * @return
	 * @uml.property  name="serviceUri"
	 */
	public String getServiceUri() {
		return serviceUri;
	}

	/**
	 * @param serviceUri
	 * @uml.property  name="serviceUri"
	 */
	public void setServiceUri(String serviceUri) {
		this.serviceUri = serviceUri;
	}

	/**
	 * @return
	 * @uml.property  name="descriptionUri"
	 */
	public String getDescriptionUri() {
		return descriptionUri;
	}

	/**
	 * @param descriptionUri
	 * @uml.property  name="descriptionUri"
	 */
	public void setDescriptionUri(String descriptionUri) {
		this.descriptionUri = descriptionUri;
	}
	public String toXML() {
		String xml = "<Service ";
		xml += "Id='" + id + "' ";
		xml += "Name='" + name + "' ";
		xml += "Type='" + type + "' ";
		xml += "Location='" + location + "' ";
		xml += "Owner='" + owner + "' ";
		xml += "Description='" + description + "' >";
		xml += "ServiceUri='" + serviceUri + "' ";
		xml += "DescriptionUri='" + descriptionUri + "' /";
		return xml;
	}
	
}
