/*
 * Copyright 2009 UbiCollab.org
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.ubicollab.rdp.tan.model;

import java.net.MalformedURLException;
import java.rmi.RemoteException;
import java.util.Hashtable;
import javax.xml.rpc.ServiceException;

import org.osgi.framework.Bundle;
import org.osgi.framework.BundleContext;
import org.osgi.framework.BundleException;
import org.ubicollab.axis.services.discoveryManager.DiscoveryManagerImpl;
import org.ubicollab.axis.services.discoveryManager.DiscoveryManagerImplServiceLocator;
import org.ubicollab.axis.services.domainManager.DomainManagerImpl;
import org.ubicollab.axis.services.domainManager.DomainManagerImplServiceLocator;



/**
 * @author  Simone
 */
public class TypeANumberPluginImpl {
	
	/**
	 * @uml.property  name="servicelist"
	 * @uml.associationEnd  
	 */
	public ServiceList servicelist = null;
	/**
	 * @uml.property  name="stub"
	 * @uml.associationEnd  
	 */
	public DiscoveryManagerImpl stub;
	/**
	 * @uml.property  name="stub2"
	 * @uml.associationEnd  
	 */
	public DomainManagerImpl stub2;
	private int pluginID = -1;
	
	public TypeANumberPluginImpl()
	{
		servicelist = new ServiceList();
		try{
			//Stub for RDM
			String sdUrl = "http://localhost:8080/axis/services/discoveryManager";
			DiscoveryManagerImplServiceLocator sdLocator = new DiscoveryManagerImplServiceLocator();
			stub = sdLocator.getdiscoveryManager(new java.net.URL(sdUrl));
			pluginID = this.connectToDiscoveryManager();
			
			//Stub for SDM
			String sdUrl2 = "http://localhost:8080/axis/services/serviceManager";
			DomainManagerImplServiceLocator sdLocator2 = new DomainManagerImplServiceLocator();
			stub2 = sdLocator2.getserviceManager(new java.net.URL(sdUrl2));			
			}
			catch (MalformedURLException e) {
				e.printStackTrace();
			} 
			catch (ServiceException e) {
				e.printStackTrace();
			} 
			catch (Exception e) {
				e.printStackTrace();
			}	
	}
	
	public int connectToDiscoveryManager()
	{
		try {
			return stub.registerSDPlugin(Settings.PLUGIN_PROTOCOL);	
		} catch (RemoteException e) {
			e.printStackTrace();
		}
		return -1;
	}
	
	public boolean registerProxy(int id){
		Service serviceToRegister = null;	
		if(servicelist.findService(id)!=null)
		{
		serviceToRegister=servicelist.findService(id);	
		System.out.println("Registering service: " + serviceToRegister.getName());
		try {
			stub.registerService(-1, pluginID, serviceToRegister.getDescriptionUri(), serviceToRegister.getServiceUri(), serviceToRegister.getName(), serviceToRegister.getType(), serviceToRegister.getDescription(), serviceToRegister.getOwner(), serviceToRegister.getLocation());
			System.out.println("DONE");
			//Install a bundle directly in the framework
			BundleContext cc = Activator.bc;
			try {
				Bundle bb = cc.installBundle(serviceToRegister.getServiceUri());
				bb.start();
				System.out.println("Proxy Service: "+serviceToRegister.getName()+" installed");
			} catch (BundleException e) {
				e.printStackTrace();
			}
		} catch (RemoteException e) 
		{
			e.printStackTrace();
		}
		return true;
		}
		else
		{
			System.out.println("Failed to install proxy" );
			return false;
		}
	}
}
