/*
 * Copyright 2009 UbiCollab.org
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.ubicollab.rdp.tan.ui;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.ui.part.ViewPart;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Text;
import com.swtdesigner.SWTResourceManager;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.events.MouseListener;
import org.eclipse.swt.events.MouseEvent;

import org.eclipse.ercp.swt.mobile.*;
import org.ubicollab.rdp.tan.model.*;

/**
 * @author  Simone
 */
public class MainView extends ViewPart {
	public static final String ID = "no.ubicollab.ui.MyViewPart"; //$NON-NLS-1$
	private Text text;
	private static MobileDevice mb=MobileDevice.getMobileDevice();
	/**
	 * @uml.property  name="tANPlugin"
	 * @uml.associationEnd  
	 */
	TypeANumberPluginImpl TANPlugin = null;
	/**
	 * @uml.property  name="servs"
	 * @uml.associationEnd  
	 */
	ServiceList servs = null;
	
	// Constructor
	public MainView() {
		TANPlugin = new TypeANumberPluginImpl(); 
		servs = new ServiceList();
	}

	// ViewPart
	public void createPartControl(Composite parent) {
		
		Composite container = new Composite(parent, SWT.NONE);
		container.setLayout(new FillLayout(SWT.VERTICAL));
		{
			Composite labels = new Composite(container, SWT.NONE);
			labels.setLayout(new FillLayout(SWT.VERTICAL));
			{
				Label lblUbicollab = new Label(labels, SWT.CENTER);
				lblUbicollab.setFont(SWTResourceManager.getFont("MS Shell Dlg", 13, SWT.NORMAL));
				lblUbicollab.setText("UbiCollab");
			}
			{
				Label lblTypeanumber = new Label(labels, SWT.CENTER);
				lblTypeanumber.setText("Type-a-Number Discovery Plugin");
			}
			{
				Label lblLookToThe = new Label(labels, SWT.CENTER);
				lblLookToThe.setText("Look to the label and type the 5-digits code");
			}
		}
		{
			Composite input_code = new Composite(container, SWT.NONE);
			input_code.setLayout(new FillLayout(SWT.HORIZONTAL));
			{
				text = new Text(input_code, SWT.BORDER | SWT.CENTER);
				text.setFont(SWTResourceManager.getFont("MS Shell Dlg", 14, SWT.BOLD));
			}
		}
		{
			//Digits Buttons
			Composite digits = new Composite(container, SWT.NONE);
			digits.setLayout(new FillLayout(SWT.HORIZONTAL));
			{
				Button digit_1 = new Button(digits, SWT.NONE);
				digit_1.addMouseListener(new MouseListener() {
					public void mouseDoubleClick(MouseEvent arg0) {
					}
					public void mouseDown(MouseEvent arg0) {
					}
					public void mouseUp(MouseEvent arg0) {
						mb.alert(MobileDevice.ALERT_HIGH_IMPORTANCE);
						text.insert("1");
					}
				});
				digit_1.setText("1");
			}
			{
				Button digit_2 = new Button(digits, SWT.NONE);
				digit_2.addMouseListener(new MouseListener() {
					public void mouseDoubleClick(MouseEvent arg0) {
					}
					public void mouseDown(MouseEvent arg0) {
					}
					public void mouseUp(MouseEvent arg0) {
						mb.alert(MobileDevice.ALERT_LOW_IMPORTANCE);
						text.insert("2");
					}
				});
				digit_2.setText("2");
			}
			{
				Button digit_3 = new Button(digits, SWT.NONE);
				digit_3.addMouseListener(new MouseListener() {
					public void mouseDoubleClick(MouseEvent arg0) {
					}
					public void mouseDown(MouseEvent arg0) {
					}
					public void mouseUp(MouseEvent arg0) {
						mb.alert(MobileDevice.ALERT_CRITICAL);
						text.insert("3");
					}
				});
				digit_3.setText("3");
			}
			{
				Button digit_4 = new Button(digits, SWT.NONE);
				digit_4.addMouseListener(new MouseListener() {
					public void mouseDoubleClick(MouseEvent arg0) {
					}
					public void mouseDown(MouseEvent arg0) {
					}
					public void mouseUp(MouseEvent arg0) {
						mb.alert(MobileDevice.ALERT_CRITICAL);
						text.insert("4");
					}
				});
				digit_4.setText("4");
			}
		}
		{
			final Composite buttons = new Composite(container, SWT.NONE);
			buttons.setLayout(new FillLayout(SWT.HORIZONTAL));
			{
				Button btnconfirm = new Button(buttons, SWT.NONE);
				btnconfirm.addMouseListener(new MouseListener() {
					public void mouseDoubleClick(MouseEvent arg0) {
					}
					public void mouseDown(MouseEvent arg0) {
					}
					public void mouseUp(MouseEvent arg0) {
						MessageBox messageBox = new MessageBox(buttons.getShell(),SWT.ICON_INFORMATION|SWT.YES|SWT.NO);
						messageBox.setText("UbiCollab");
						messageBox.setMessage("Add: "+ servs.findServiceName(Integer.parseInt(text.getText()))+" ?");
						int confirm = messageBox.open();
						switch (confirm)
						{
						case SWT.YES:
						{
						TANPlugin.registerProxy(Integer.parseInt(text.getText()));
						MessageBox operationSuccessful = new MessageBox(buttons.getShell());
						operationSuccessful.setText("Operation Succesfull");
						operationSuccessful.setMessage(servs.findServiceName(Integer.parseInt(text.getText()))+" installed in the UbiNode");
						operationSuccessful.open();
						//Activator.getDefault().getWorkbench().restart();
						}
						break;
						case SWT.NO:
						{
							text.selectAll();
							text.cut();
						}
						break;
						}
					}
				});
				btnconfirm.setText("DISCOVER!");
			}
			{
				Button btnAvoid = new Button(buttons, SWT.NONE);
				btnAvoid.addMouseListener(new MouseListener() {
					public void mouseDoubleClick(MouseEvent arg0) {
					}
					public void mouseDown(MouseEvent arg0) {
					}
					public void mouseUp(MouseEvent arg0) {
						text.selectAll();
						text.cut();
						Activator.getDefault().getWorkbench().getDisplay().readAndDispatch();
						System.out.println("eWorkbench restarted");
					}
				});
				btnAvoid.setText("AVOID");
			}
		}
	}
	public void setFocus() {
		// set the focus
	}
}
