/*
 * Copyright 2009 UbiCollab.org
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.ubicollab.service.imgpresenter.model;



import org.eclipse.swt.widgets.Display;
import org.ubicollab.service.imgpresenter.ui.*;

/**
 * @author  Simone
 */
public class Controller implements ImagePresenter{
	/**
	 * @uml.property  name="view"
	 * @uml.associationEnd  
	 */
	MainView view =null;
	/**
	 * @uml.property  name="model"
	 * @uml.associationEnd  
	 */
	Activator model = null;
	/**
	 * @uml.property  name="instance"
	 * @uml.associationEnd  
	 */
	private static Controller instance = null;
	static Display disp = null;
	String actualImage;
	
	protected Controller()
	{	
	}
	
	/**
	 * @return
	 * @uml.property  name="instance"
	 */
	public static Controller getInstance() 
	{
		if(instance == null) 
		{
			instance = new Controller();
			}
		return instance;
		}
		
	public static void setDisplay(Display display)
	{
		disp=display;
		}
	public void registerView (MainView v)
	{
		view = v;
		}
	public void registerModel (Activator mod)
	{
		model=mod;
		}
	public void drawTarget(String target) {
		final String ind=target;
		actualImage=target;
		disp.asyncExec(new Runnable(){
			public void run() {
			view.drawTarget(ind);
			}	
		});	
	}

	public String getDeviceInfo() {
		return "UbiCollab Remote Presenter";
	}

	public String getImageInformation() {
		return "Image location: " + actualImage; 
	}

	public void showAdvertaisment() {
		final String ind="/res/adv.jpg";
		actualImage="/res/adv.jpg";
		disp.asyncExec(new Runnable(){
			public void run() {
			view.drawTarget(ind);
			}	
		});				
	}

	public void showTarget(String targetUrl) {
		final String ind=targetUrl;
		actualImage=targetUrl;
		disp.asyncExec(new Runnable(){
			public void run() {
			view.drawTarget(ind);
			}	
		});			
	}	
}
