/*
 * Copyright 2009 UbiCollab.org
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.ubicollab.service.openwall.model;

import java.util.Properties;


import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceRegistration;
import org.ubicollab.service.openwall.ui.MainView;
/**
 * The activator class controls the plug-in life cycle
 */
public class Activator extends AbstractUIPlugin {
	
	
	/**
	 * @uml.property  name="controller"
	 * @uml.associationEnd  
	 */
	private Controller controller = null;
	// The plug-in ID
	public static final String PLUGIN_ID = "no.ubicollab.app.imageViewer_Server";

	// The shared instance
	/**
	 * @uml.property  name="plugin"
	 * @uml.associationEnd  
	 */
	private static Activator plugin;
	
	/**
	 * The constructor
	 */
	public Activator() {
	}

	/*
	 * (non-Javadoc)
	 * @see org.eclipse.ui.plugin.AbstractUIPlugin#start(org.osgi.framework.BundleContext)
	 */
	public void start(BundleContext context) throws Exception {
		super.start(context);
		plugin = this;
		
		//WS registration
		Properties properties = new Properties();
		properties.put("Language", "English");
		properties.put("SOAP.service.name", "ImageViewer_Server");
		
		//Service Registration
		controller = Controller.getInstance();  //Controller is an implementation of imageviewer
		controller.registerModel(this);
		ServiceRegistration registration = context.registerService(IOWPresenter.class.getName(), controller, properties); 
		System.out.println("Service registered: UC_ImageViewer"); 
		} 
		
	/*
	 * (non-Javadoc)
	 * @see org.eclipse.ui.plugin.AbstractUIPlugin#stop(org.osgi.framework.BundleContext)
	 */
	public void stop(BundleContext context) throws Exception {
		plugin = null;
		super.stop(context);
	}

	/**
	 * Returns the shared instance
	 *
	 * @return the shared instance
	 */
	public static Activator getDefault() {
		return plugin;
	}

}
