/*
 * Copyright 2009 UbiCollab.org
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.ubicollab.service.openwall.model;


import org.eclipse.swt.widgets.Display;
import org.ubicollab.service.openwall.ui.*;

/**
 * @author  Simone
 */
public class Controller implements IOWPresenter{

	
	 	/**
		 * @uml.property  name="view"
		 * @uml.associationEnd  
		 */
	 	MainView view =null;
		/**
		 * @uml.property  name="model"
		 * @uml.associationEnd  
		 */
		Activator model = null;
		/**
		 * @uml.property  name="instance"
		 * @uml.associationEnd  
		 */
		private static Controller instance = null;
		static Display disp = null;
		
		protected Controller()
		{	
		}
		
		/**
		 * @return
		 * @uml.property  name="instance"
		 */
		public static Controller getInstance() {
		      if(instance == null) {
		         instance = new Controller();
		      }
		      return instance;
		   }
		
		public static void setDisplay(Display display)
		{
			disp=display;
		}
		public void registerView (MainView v)
		{
			view = v;
		}
		public void registerModel (Activator mod)
		{
			model=mod;
		}
		
	public void drawNext() {
		// TODO Auto-generated method stub
		disp.asyncExec(new Runnable(){
			public void run() {
				view.drawNext();
			}	
		});
	}
	public void drawPrevious() {
		disp.asyncExec(new Runnable(){
			public void run() {
				view.drawPrevious();
			}	
		});
	}
	public void drawTarget(int index) {
		// TODO Auto-generated method stub
		final int ind=index;
		disp.asyncExec(new Runnable(){
			public void run() {
			view.drawTarget(ind);
			}	
		});	
	}
	

}
